<template>
  <el-dialog
    append-to-body
    :title="textMap[dialogStatus]"
    :visible.sync="dialogFormVisible"
  >
    <el-form
      ref="dataForm"
      :rules="rules"
      :model="deviceForm"
      label-width="100px"
      label-well-code="right"
    >
      <el-row :gutter="20">
        <el-col :span="12">
          <el-form-item label="项目编码" prop="tenantCode">
            <el-input
              v-model="deviceForm.tenantCode"
              clearable
              placeholder="请输入与项目编码"
              :disabled="dialogStatus === 'create' ? false : true"
            />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="项目名称" prop="tenantName">
            <el-input
              v-model="deviceForm.tenantName"
              placeholder="请输入项目名称"
              clearable
              :disabled="dialogStatus === 'create' ? false : true"
            />
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="20">
        <el-col :span="12">
          <el-form-item label="项目联系人" prop="linkPerson">
            <el-input
              v-model="deviceForm.linkPerson"
              placeholder="请输入项目联系人"
              clearable
              :disabled="dialogStatus === 'detail' || dialogStatus === 'makeDep' ? true : false"
            />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="联系电话" prop="tel">
            <el-input
              v-model="deviceForm.tel"
              placeholder="请输入联系电话"
              clearable
              :disabled="dialogStatus === 'detail' || dialogStatus === 'makeDep' ? true : false"
            />
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="20">
        <el-col :span="12">
          <el-form-item label="历史保存天数" prop="clearday">
            <el-input
              v-model="deviceForm.clearday"
              placeholder="请输入历史数据保存天数"
              clearable
              :disabled="dialogStatus === 'detail' || dialogStatus === 'makeDep' ? true : false"
            />
          </el-form-item>
        </el-col>
        <el-col v-if="dialogStatus === 'makeDep' ? true : false" :span="12">
          <el-form-item label="组织名称" prop="deptName">
            <dept-select
              v-model="deviceForm.deptName"
              :need-top="deptShowTop"
              dept-type="03"
              placeholder="选择权属单位"
            />
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <div
      v-show="dialogStatus === 'detail' ? false : true"
      slot="footer"
      class="dialog-footer"
    >
      <el-button type="primary" @click="saveData">
        保存
      </el-button>
      <el-button @click="dialogFormVisible = false">
        取消
      </el-button>
    </div>
  </el-dialog>
</template>

<script>
import { getDevice, updateTenant, addTenant } from '@/api/system/tenant'
import DeptSelect from '@/components/DeptSelect/index'
export default {
  name: 'EditTenant',
  components: { DeptSelect },
  data() {
    return {
      dialogFormVisible: false, // 对话框显示隐藏
      dialogStatus: '', // 对话框类型：create,update,detail
      deptShowTop: false,
      // 对话框标题
      textMap: {
        update: '编辑',
        create: '新增',
        detail: '详情',
        makeDep: '绑定组织'
      },
      // 表单内容
      deviceForm: {
        id: '', // 主键
        tenantCode: '', // 项目编码
        tenantName: '', // 项目名称
        linkPerson: '', // 联系人
        tel: '', // 联系电话
        clearday: '' // 清除时间
      },
      // 表单校验规则
      rules: {
        tenantCode: [{ required: true, message: '项目编码不能为空', trigger: ['blur', 'change'] }],
        tenantName: [{ required: true, message: '项目名称不能为空', trigger: ['blur', 'change'] }]
      }
    }
  },
  created() {
  },
  methods: {
    // 重置表单
    resetForm() {
      this.deviceForm = {
        tenantCode: '',
        tenantName: '',
        linkPerson: '',
        tel: '',
        clearday: '',
        deptName: ''
      }
    },
    // 父子组件通信
    initDialog(dialogStatus, row = null) {
      this.dialogFormVisible = true
      this.dialogStatus = dialogStatus
      if (this.dialogStatus === 'create') {
        this.resetForm()
        this.$nextTick(() => {
          this.$refs['dataForm'].clearValidate()
        })
      } else if (this.dialogStatus === 'update' || this.dialogStatus === 'detail' || this.dialogStatus === 'makeDep') {
        this.deviceForm = {
          id: row.id,
          tenantCode: row.tenantCode,
          tenantName: row.tenantName,
          linkPerson: row.linkPerson,
          tel: row.tel,
          clearday: row.clearday
        }
      }
    },
    // 保存数据
    saveData() {
      if (this.dialogStatus === 'update') {
        this.updateData()
      } else if (this.dialogStatus === 'create') {
        this.createData()
      }
    },
    // 修改数据
    updateData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          updateTenant(this.deviceForm).then(response => {
            if (response.code === 200) {
              this.$message.success('修改成功')
              this.$emit('watchChild')
              this.dialogFormVisible = false
            }
          })
        }
      })
    },
    // 新增数据
    createData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          addTenant(this.deviceForm).then(response => {
            if (response.code === 200) {
              this.$message.success('新增成功')
              this.$emit('watchChild')
              this.dialogFormVisible = false
            }
          })
        }
      })
    }
  }
}
</script>
